VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "AVT-718 FLASH Download"
   ClientHeight    =   6510
   ClientLeft      =   8220
   ClientTop       =   4005
   ClientWidth     =   6720
   ControlBox      =   0   'False
   Icon            =   "718flash.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6510
   ScaleWidth      =   6720
   Begin VB.CommandButton ClearDebugList 
      Caption         =   "Clear Debug"
      Height          =   255
      Left            =   4680
      TabIndex        =   12
      Top             =   6120
      Width           =   1695
   End
   Begin VB.CommandButton ClearStatusList 
      Caption         =   "Clear Status"
      Height          =   255
      Left            =   4800
      TabIndex        =   11
      Top             =   2040
      Width           =   1695
   End
   Begin VB.CommandButton VerifyFlash 
      Caption         =   "Verify FLASH"
      Height          =   375
      Left            =   120
      TabIndex        =   10
      Top             =   4320
      Width           =   1695
   End
   Begin MSWinsockLib.Winsock Winsock1Data 
      Left            =   3720
      Top             =   3600
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.ListBox List2 
      Height          =   1425
      Left            =   2040
      TabIndex        =   9
      Top             =   4680
      Width           =   4335
   End
   Begin VB.ListBox List1 
      Height          =   1815
      Left            =   240
      TabIndex        =   8
      Top             =   240
      Width           =   6255
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   10
      Left            =   3000
      Top             =   3600
   End
   Begin VB.TextBox Text3 
      Height          =   285
      Left            =   1920
      TabIndex        =   5
      Top             =   3000
      Width           =   4455
   End
   Begin VB.TextBox Text2 
      Height          =   285
      Left            =   1920
      TabIndex        =   4
      Top             =   2400
      Width           =   4455
   End
   Begin VB.CommandButton SelectDataPipe 
      Caption         =   "Select Data Pipe"
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   2880
      Width           =   1695
   End
   Begin VB.CommandButton AbortProgram 
      Caption         =   "Exit / Abort"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   6000
      Width           =   1695
   End
   Begin VB.CommandButton ProgramFlash 
      Caption         =   "Program FLASH"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   3600
      Width           =   1695
   End
   Begin VB.CommandButton SelectSourceFile 
      Caption         =   "Select Source File"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   2280
      Width           =   1695
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   2280
      Top             =   3600
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "Debug"
      Height          =   255
      Left            =   3960
      TabIndex        =   7
      Top             =   4440
      Width           =   1215
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Status"
      Height          =   255
      Left            =   2880
      TabIndex        =   6
      Top             =   0
      Width           =   1215
   End
   Begin VB.Menu menuHelp 
      Caption         =   "Help"
      NegotiatePosition=   3  'Right
      Begin VB.Menu menuHelpAbout 
         Caption         =   "About"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' ####################
' form1
' file:  718flash.frm


' ####################
' option declarations
    ' explicitly declare all variables
Option Explicit
    ' array base is 0
Option Base 0


' ####################
' Operational notes
' It appears that system WinSock routines don't run, while this program executes.
' Must return to the system for WinSock to update.
' When using WinSock/Ethernet to talk to the AVT interface all program mode routines
' assume that if the first byte can be read, then all other bytes are probably there.
' So, when entering a program mode routine that reads a byte, I check if a byte can be
' read.  If not, I check the FailTimer.  If not zero, I leave to wait some more.
' If I can read a byte upon entry, then I try to read them all.
' If any read fails in a routine, the routine will bomb out and the process is aborted.
' This is not desirable and needs to be fixed.
'
' 6 April 2004
' Modified the GetAByte routine.  Added a timeout feature.
' I try to read a byte until either a byte is read or the fail timer
' expires (goes to zero).
'
' 26 May 2004
' Removed the loop in the GetAByte routine.
' The fail timer does not update if we are stuck in the GetAByte routine.
' Thus, the program locked up.
' When GetAByte is called, one read is attempted and the routine returns.
' The returned value is either the byte read or -1 if nothing is read.
'
' 21 June 2004
' Customers experiencing "E18" failures due to the host computer able to
' read the serial port faster than data would show up.
' Added a wait feature, or loop, in the GetAByte routine.
' The wait loop uses the system clock to update - appears to work
' for the serial port.
' It will not work for the WinSock routines.
' I still have to update the whole structure of the program to allow
' exiting the program while I wait for data from the interface device.
' This "fix" is only a temporary stop-gap measure since we still
' have not sold any AVT-418 units yet.
'
' 14 August 2004
' Start work on revamping the program.
' Need to 'fix' the timeout problem/issue.
' Want to add a 'verify' feature.
' All program modes have been redefined.
'
' 19 September 2004
' Finally back on this project.
' Decided to implement this as one big state machine.
'
' 11 January 2005
' Changes to this program to flush any/all bytes from the AVT-418/718 unit
' after sending the reset command.
' Why:  One special version of firmware for the AVT-418/718 automatically
' enters an operational mode at power-on.
' The reports from that fake out this application and cause it to fail.
'
' 17 June 2009
' Tried to figure out a way a flush any/all bytes from the AVT-418/718 unit
' after sending the reset command for the "VERIFY" operation.
' Recent production boards do not have the PWM device installed.
' Firmware version 6.6 (6.7 as well ??) will send a "21 01" error
' code on reset that confuses the "VERIFY" routine.

' ####################
    ' program/programming mode - this application is one big state machine
Private ProgramMode As Integer

        ' definitions
    ' 00 = start up / idle state

    ' -------------------
    '   start-up sequence - attempting to start programming, reset command just sent
    ' 21 = waiting for "91" response

    ' 22 = waiting for "12" response
    '               or "2E" response

    ' 23 = waiting for "92" response

    ' 24 = waiting for "04" response

    ' 25 = waiting for "xx" response

    ' 90 = waiting and flushing the serial port

    ' 26 = waiting for "91" response

    ' 27 = waiting for "2E" response

    ' 28 = waiting for "92" response

    ' 29 = waiting for "04" response

    ' 30 = waiting for "xx" version number

    ' ----------------
    '   FLASH sequence
    ' 41 = read, store, and send the first block of data

    ' 42 = read, store and send subsequent block of data

    ' 43 = wait for "61" response

    ' 44 = wait for "3A" response
    '      send dump command

    ' 45 = wait for "61" response

    ' 46 = wait for "37" response

    ' 47 = verify block

    ' 48 = wait for last "61" response

    ' 49 = wait for last "3A" response
    '      send dump command

    ' 50 = wait for last "61 response

    ' 51 = wait for last "37" response

    ' 52 = verify last block

    ' -----------------
    '   verify sequence
    ' 61 = waiting for "91" response

    ' 62 = waiting for "12" response
    '               or "2E" response

    ' 63 = waiting for "92" response

    ' 64 = waiting for "04" response

    ' 65 = waiting for "xx" response

    ' 91 = waiting and flushing the serial port

    ' 66 = waiting for "91" response

    ' 67 = waiting for "2E" response

    ' 68 = waiting for "92" response

    ' 69 = waiting for "04" response

    ' 70 = waiting for "xx" version number

    ' 71 = read and store first block of data
    '      send the dump command

    ' 72 = read and store subsequent block of data
    '      send the dump command
    
    ' 73 = wait for "61" response

    ' 74 = wait for "37" response

    ' 75 = verify block

    ' 76 = wait for last "61" response

    ' 77 = wait for last "37" response

    ' 78 = verify last block




' ####################
' communications variables

    ' how to communicate with interface unit
Public DataPipe As Integer
    ' = 0 if not declared
    ' = 1 if serial com port
    ' = 5 if Ethernet (TCP/IP)

    ' ethernet connection status
Private EthernetConnection As Boolean

    ' ethernet host IP address
Public IPAddress As String

    ' ethernet host port number
Public PortNumber As Long


' ####################
' com port variables

Private ComPortOpen As Boolean
    ' = false if com port not open
    ' = true if com port is open

    ' com port number
Public ComPort As Long
    ' this is an index and the com port number
  
    ' com port baud rate
Public ComSpeed As Integer
    ' this is an index only

    ' com port IRQ
Public ComIRQ As Integer
    ' this is an index only

    ' com port I/O address
Public ComAddr As Integer

    ' port control block
Private current_pcb As port_param

    ' returned status from COMM-DRV/Lib calls
Private stat As Long

    ' data byte just read from com buffer
Private InData As Long

    ' data byte to be transmitted
Private OutData As Long


' ####################
' Ethernet receive variables
Private ReceiveData() As Byte
Private ReceiveDataIndex As Long
Private ReceiveDataUBound As Long


' ####################
' transmit packet array
Const MaxTransmitPacketSize = 300
Private TransmitPacket(0 To MaxTransmitPacketSize) As Long
Private TransmitPacketLength As Long


' ####################
' Fifo 1 variables

    ' buffer constants
Const Bottom1 = 0
Const Top1 = 1024

    ' buffer
Private Fifo1(Bottom1 To Top1) As Byte
    ' head index
Private Head1 As Long
    ' tail index
Private Tail1 As Long
    ' empty flag
Private EmptyFlag1 As Boolean
    ' full flag
Private FullFlag1 As Boolean


' ####################
' control variables

    ' timer ISR flag
Private TimerIsrActive As Boolean

    ' winsock ISR flag
Private WinsockIsrActive As Boolean

    ' read fail timer
Private FailTimer As Long
Private FailTimerReset As Long


' ####################
' Display variables
    
    ' text message for list1 - comms
Private Msg1 As String
    ' text message for list2 - debug
Private Msg2 As String


' ####################
' S19 file is opened as #1

    ' file mode
Private S19FileMode As Integer
    ' = 0 if the file is not defined
    ' = 1 if the file has just been opened
    ' = 2 if the file is in-use
    ' = 3 if the EOF has been encountered

    ' name of the S19 source file
Private S19FileName As String


' ####################
' S19 variables

    ' type of S19 record last read
Dim Record As String * 2
    ' character version of a byte
Dim CharPair As String * 2
    ' character count of current file line
Dim LineCount As Integer
    ' destination address of current file line
Dim LineAddr As Long
    ' pointer of next expected memory address
Dim PtrAddr As Long
    ' starting address of the current block
Dim BlockAddr As Long
    ' buffer holding current block of data
Dim BlockBuff(0 To 256) As Byte
    ' index into the block buffer
Dim BlockIndex As Integer
    ' hold block address while checking for even block address
Dim ChkAddr As Long
    ' flag to indicate that record just read is valid
Dim GoodRecord As Boolean
    ' flag to indicate that a record was just opened, but hasn't been read yet
Dim BrandNewRecord As Boolean
    ' temporary pointer
Dim Ix As Integer


' ####################
' program flash variables

    ' address byte - for command
Dim Byte3 As Byte
    ' address byte - for command
Dim Byte2 As Byte
    ' address byte - for command
Dim Byte1 As Byte
    ' address byte - for command
Dim Byte0 As Byte
    ' address byte - read from S19 record
Dim Addr3 As Long
    ' address byte - read from S19 record
Dim Addr2 As Long
    ' address byte - read from S19 record
Dim Addr1 As Long
    ' address byte - read from S19 record
Dim Addr0 As Long


' ####################
' memory dump/compare variables
Dim VerifyErrorCount As Long
Dim BlockErrorCount As Long
Dim VerifyIndex As Integer

Private Sub AbortProgram_click()
    ' abort program

    ' if we're in the isr, exit for now
If TimerIsrActive = True Then
    Msg2 = "Exit failed. Timer stopped. --> Try again! [TimerIsrActive]"
    Call PostMsg2(Msg2)
    Timer1.Enabled = False
    Exit Sub
End If

    ' if we're in the isr, exit for now
If WinsockIsrActive = True Then
    Msg2 = "Exit failed. Timer stopped. --> Try again! [WinsockIsrActive]"
    Call PostMsg2(Msg2)
    Timer1.Enabled = False
    Exit Sub
End If

    ' disable timer1
Timer1.Enabled = False
TimerIsrActive = False

    ' close the ethernet connection
If EthernetConnection = True Then
    Winsock1Data.Close
    Msg2 = "Ethernet connection closed."
    Call PostMsg2(Msg2)

    EthernetConnection = False
    WinsockIsrActive = False

End If

    ' close open com port
If ComPortOpen = True Then
    stat = UnInitializePort&(ComPort)
    If stat <> RS232ERR_NONE Then
        Msg2 = "Error: " & stat & " closing COM port: " & ComPort
        Call PostMsg2(Msg2)
    Else
        Msg2 = "Closed COM port: " & ComPort
        Call PostMsg2(Msg2)
    End If

    ComPortOpen = False

End If

    ' close the S19 file
If S19FileMode <> 0 Then
    Close #1
    Msg2 = "Closed the S19 file."
    Call PostMsg2(Msg2)
End If

Msg1 = "Program terminated.  Short delay."
Call PostMsg1(Msg1)

    ' current clock, in seconds, from system
Dim Seconds As Integer

    ' get the current system time, in seconds
Seconds = Val(Format$(Now, "ss"))

    ' display the form for 1 second
Seconds = Seconds + 1
If Seconds > 59 Then
    Seconds = Seconds - 60
End If

Do
    ' kill time
Loop While Seconds <> Val(Format$(Now, "ss"))

    ' unload the form
Unload Form1
    ' end this program
End

    ' end of abort program
End Sub

Private Sub FlushDataPipe()
    ' flush the selected data pipe

    ' local variable
Dim IndexF As Integer

    ' flush the com port
If DataPipe = 1 Then
    stat = FlushReceiveBuffer(ComPort)
    If stat <> RS232ERR_NONE Then
        Msg2 = "** Error flushing receive buffer: " & stat
        Call PostMsg2(Msg2)
    End If

    stat = FlushTransmitBuffer(ComPort)
    If stat <> RS232ERR_NONE Then
        Msg2 = "** Error flushing transmit buffer: " & stat
        Call PostMsg2(Msg2)
    End If

    ' flush fifo 1
ElseIf DataPipe = 5 Then
        ' initialize fifo1
    For IndexF = Bottom1 To Top1
        Fifo1(IndexF) = 0
    Next IndexF
    EmptyFlag1 = True
    FullFlag1 = False
    Head1 = Bottom1
    Tail1 = Bottom1

Else
    Msg2 = "Invalid DataPipe in FlushDataPipe: " & DataPipe
    Call PostMsg2(Msg2)

End If

    ' end of flush data pipe
End Sub

Private Sub GetAByte()
    ' attempt to get a byte from the data pipe
    
    ' initialize indata
InData = -1

    ' read from the serial port
If DataPipe = 1 Then

        ' read a byte - first try
        ' this is supposed to speed up reading the com port
    stat = ser_rs232_getpacket(ComPort, 0, 0)
    If stat <> RS232ERR_NONE Then
        Msg2 = "Error getting a packet: " & stat
        Call PostMsg2(Msg2)
        Exit Sub

    Else
            ' no error, read the byte
        InData = GetByte(ComPort)
        If InData <> -1 Then
            Exit Sub
        End If

    End If

        ' no byte read, flag it and exit
    InData = -1

    ' read from the ethernet connection
ElseIf DataPipe = 5 Then
    InData = ReadFifo1

Else
    Msg2 = "Invalid DataPipe in GetAByte: " & DataPipe
    Call PostMsg2(Msg2)

End If

    ' end of get a byte
End Sub

Public Sub InitComPort()
    ' initialize the com port

    ' sub port id for comm-drv/lib
Dim subport As Long

If (ComPort < 1) Or (ComPort > 4) Then
    Msg2 = "COM Port selection is invalid."
    Call PostMsg2(Msg2)
    Exit Sub
End If

If (ComSpeed < 1) Or (ComSpeed > 4) Then
    Msg2 = "COM Speed selection is invalid."
    Call PostMsg2(Msg2)
    Exit Sub
End If

If Not ((ComIRQ = 4) Or (ComIRQ = 3) Or (ComIRQ = 5) Or (ComIRQ = 7)) Then
    Msg2 = "COM IRQ selection is invalid."
    Call PostMsg2(Msg2)
    Exit Sub
End If

If Not ((ComAddr = &H3F8) Or (ComAddr = &H2F8) Or (ComAddr = &H3E8) Or (ComAddr = &H2E8)) Then
    Msg2 = "COM I/O address selection is invalid."
    Call PostMsg2(Msg2)
    Exit Sub
End If

If ComPortOpen = False Then

    subport = ComPort - 1

        ' initialize and open the com port
    stat = InitializePort&(ComPort, subport, ComAddr, ComIRQ, CARD_WINAPI, 0, 8192, 8192, 0)
    If stat <> RS232ERR_NONE Then
        Msg2 = "Error initializing COM port: " & stat
        Call PostMsg2(Msg2)
        Exit Sub
    End If

        ' get the port control block
    stat = ser_rs232_getport(ComPort, current_pcb)
    If stat <> RS232ERR_NONE Then
        Msg2 = "Error setting COM port parameters: " & stat
        Call PostMsg2(Msg2)
        Exit Sub
    End If

        ' set the port characteristics
    If ComSpeed = 1 Then
        current_pcb.Baud = BAUD19200
    ElseIf ComSpeed = 2 Then
        current_pcb.Baud = BAUD38400
    ElseIf ComSpeed = 3 Then
        current_pcb.Baud = BAUD57600
    ElseIf ComSpeed = 4 Then
        current_pcb.Baud = BAUD115200
    Else
        Msg2 = "Error in selecting baud rate."
        Call PostMsg2(Msg2)
        Exit Sub
    End If

    current_pcb.Parity = PAR_NONE
    current_pcb.lngth = LENGTH_8
    current_pcb.stopbit = STOPBIT_1
    current_pcb.protocol = PROT_RTSRTS

        ' set up the port for those characteristics
    stat = SetPortCharacteristics&(ComPort, current_pcb.Baud, current_pcb.Parity, current_pcb.lngth, current_pcb.stopbit, current_pcb.protocol)
    If stat <> RS232ERR_NONE Then
        Msg2 = "Error setting COM port characteristics: " & stat
        Call PostMsg2(Msg2)
        Exit Sub
    End If

        ' set the timer resolution to 1 millisecond
    stat = CdrvSetTimerResolution(ComPort, 1)
    If stat <> RS232ERR_NONE Then
        Msg2 = "Error setting timer resolution: " & stat
        Call PostMsg2(Msg2)
    End If

        ' set the timeout for read and write operations
    stat = SetTimeout(ComPort, 1)
    If stat <> RS232ERR_NONE Then
        Msg2 = "Error setting time out: " & stat
        Call PostMsg2(Msg2)
    End If

        ' set the pace time for write operations
    stat = SetPaceTime(ComPort, 0)
    If stat <> RS232ERR_NONE Then
        Msg2 = "Error setting pace time: " & stat
        Call PostMsg2(Msg2)
    End If

    Msg1 = "COM port initialized and opened."
    Call PostMsg1(Msg1)

    Text3.Text = "COM" & ComPort & ": at "
    If ComSpeed = 1 Then
        Text3.Text = Text3.Text & "19.2 kbaud"
    ElseIf ComSpeed = 2 Then
        Text3.Text = Text3.Text & "38.4 kbaud"
    ElseIf ComSpeed = 3 Then
        Text3.Text = Text3.Text & "57.6 kbaud"
    ElseIf ComSpeed = 4 Then
        Text3.Text = Text3.Text & "115.2 kbaud"
    Else
        Text3.Text = Text3.Text & "** ERROR **"
    End If

    ComPortOpen = True
    Call FlushDataPipe

        ' initialize transmit packet length counter
    TransmitPacketLength = 0

        ' initialize timer isr flag
    TimerIsrActive = False

        ' enable timer1
    Timer1.Enabled = True

Else
    Msg2 = "** ERROR ** COM Port already open."
    Call PostMsg2(Msg2)
    Exit Sub

End If

    ' end of init com port
End Sub

Public Sub InitVariables()
    ' initialize all program variables at start-up

    ' local variable
Dim Index As Integer

    ' initialize program mode
ProgramMode = 0

    ' clear text boxes on form1
List1.Clear
List2.Clear
Text2.Text = ""
Text3.Text = ""

    ' set the insertion point of text boxes
Text2.SelStart = Len(Form1.Text2.Text)
Text3.SelStart = Len(Form1.Text3.Text)

    ' initialize global message variables
Msg1 = ""
Msg2 = ""

    ' disable timer1
Timer1.Enabled = False
    ' set timer1 interval
Timer1.Interval = 50

    ' initialize the fail timer
FailTimer = 0
    ' initialize fail timer reset = 3 seconds
FailTimerReset = 3000 / Timer1.Interval

    ' default data pipe is serial com port
DataPipe = 1

    ' com port is not open
ComPortOpen = False
    ' com port 1 is default
ComPort = 1
    ' 19.2 kbaud is default
ComSpeed = 1
    ' IRQ of 4 is default
ComIRQ = 4
    ' com I/O address $3F8 is default
ComAddr = &H3F8

    ' initialize com stat
stat = 0

    ' initialize indata
InData = -1
    ' initialize outdata
OutData = 0

    ' default ethernet connection
EthernetConnection = False

    ' default ethernet address
IPAddress = "192.168.1.70"
Form2.IPAddress = IPAddress

    ' default port number
PortNumber = 10001
Form2.PortNumber = PortNumber

    ' initialize ethernet receive data
ReceiveDataIndex = 1
ReceiveDataUBound = 0

    ' initialize control variables
TimerIsrActive = False
WinsockIsrActive = False

    ' initialize transmit array
TransmitPacketLength = 0
For Index = 0 To MaxTransmitPacketSize
    TransmitPacket(Index) = 0
Next Index

    ' initialize fifo1 variables
For Index = Bottom1 To Top1
    Fifo1(Index) = 0
Next Index
EmptyFlag1 = True
FullFlag1 = False
Head1 = Bottom1
Tail1 = Bottom1

    ' no input file defined
S19FileName = ""
    ' input file is not open
S19FileMode = 0

    ' initialize s19 variables
Record = "xx"
CharPair = "xx"
LineCount = 0
LineAddr = 0
PtrAddr = 0
BlockAddr = 0
For Index = 0 To 255
    BlockBuff(Index) = 0
Next Index
ChkAddr = 0
GoodRecord = False
BrandNewRecord = False
Ix = 0

    ' initialize program flash variables
Byte3 = 0
Byte2 = 0
Byte1 = 0
Byte0 = 0
Addr3 = 0
Addr2 = 0
Addr1 = 0
Addr0 = 0

VerifyErrorCount = 0
VerifyIndex = 0
BlockErrorCount = 0

    ' initialize form1 buttons
SelectDataPipe.Enabled = True
SelectSourceFile.Enabled = True
ProgramFlash.Caption = "Program FLASH"
ProgramFlash.Enabled = True
VerifyFlash.Caption = "Verify FLASH"
VerifyFlash.Enabled = True

    ' initialize form2 option buttons
Form2.ComxBtn(ComPort).value = True
Form2.ComBaudBtn(ComSpeed).value = True
Form2.ComIoBtn(ComAddr).value = True
Form2.ComIrqBtn(ComIRQ).value = True
Form2.DataPipeSelect(DataPipe).value = True

    ' enable form2 com port selections
Form2.ComxBtn(1).Enabled = True
Form2.ComxBtn(2).Enabled = True
Form2.ComxBtn(3).Enabled = True
Form2.ComxBtn(4).Enabled = True

Form2.ComBaudBtn(1).Enabled = True
Form2.ComBaudBtn(2).Enabled = True
Form2.ComBaudBtn(3).Enabled = True
Form2.ComBaudBtn(4).Enabled = True

Form2.ComIoBtn(&H3F8).Enabled = True
Form2.ComIoBtn(&H2F8).Enabled = True
Form2.ComIoBtn(&H3E8).Enabled = True
Form2.ComIoBtn(&H2E8).Enabled = True

Form2.ComIrqBtn(4).Enabled = True
Form2.ComIrqBtn(3).Enabled = True
Form2.ComIrqBtn(5).Enabled = True
Form2.ComIrqBtn(7).Enabled = True

    ' disable form2 ethernet fields
Form2.IPAddress.Enabled = False
Form2.PortNumber.Enabled = False

    ' end of initialize variables
End Sub

Public Sub InitWinSock()
    ' initialize the winsock connection

    With Winsock1Data
        .protocol = sckTCPProtocol
        .RemoteHost = IPAddress
        .RemotePort = PortNumber
        .Connect
    End With

    WinsockIsrActive = False

    Msg2 = "Ethernet connection pending."
    Call PostMsg2(Msg2)

End Sub

Private Sub mnuHelp_Click()
    ' help menu button

    ' end of help menu button
End Sub

Private Sub ClearDebugList_Click()
    ' clear the debug list

List2.Clear

    ' end of clear debug list
End Sub

Private Sub ClearStatusList_Click()
    ' clear the status list

List1.Clear

    ' end of clear the status list
End Sub

Private Sub menuHelpAbout_click()
    ' help about window

Load frmAbout
frmAbout.Show

    ' end of help about window
End Sub

Private Function Number2(InString As String) As Byte
    ' convert a 2 character input string to a byte number

Dim nib1 As String * 1
Dim nib0 As String * 1

nib1 = Mid$(InString, 1, 1)
nib0 = Mid$(InString, 2, 1)

Dim Temp As Byte

Temp = 0

If Asc(nib1) >= &H30 And Asc(nib1) <= &H39 Then
    Temp = Temp + 16 * (Asc(nib1) - &H30)
ElseIf Asc(nib1) >= &H41 And Asc(nib1) <= &H46 Then
    Temp = Temp + 16 * (Asc(nib1) - &H37)
Else
    Msg2 = "Nib1 not valid: " & Hex$(Asc(nib1))
    Call PostMsg2(Msg2)
End If

If Asc(nib0) >= &H30 And Asc(nib0) <= &H39 Then
    Temp = Temp + (Asc(nib0) - &H30)
ElseIf Asc(nib0) >= &H41 And Asc(nib0) <= &H46 Then
    Temp = Temp + (Asc(nib0) - &H37)
Else
    Msg2 = "Nib0 not valid: " & Hex$(Asc(nib0))
    Call PostMsg2(Msg2)
End If

Number2 = Temp

    ' end of number2
End Function

Private Sub PadBlock()
    ' pad the block with &FF in preparation to sending it

If BlockIndex = 256 Then
    Exit Sub

ElseIf BlockIndex = 0 Then
    Exit Sub

End If

For Ix = BlockIndex To 256
    BlockBuff(Ix) = &HFF
Next Ix

    ' end of pad block
End Sub

Private Sub PostMsg1(Msgx As String)
    ' post message to list 1 - comm window

With List1
    .AddItem Msgx
    .ListIndex = .NewIndex
    .Selected(.ListIndex) = False
    .Refresh
End With

If List1.ListCount > 200 Then
    Do
        List1.RemoveItem (0)
    Loop Until List1.ListCount <= 200
End If

    ' end of post message 1
End Sub

Public Sub PostMsg2(Msgy As String)
    ' post message to list 2 - debug window

With List2
    .AddItem Msgy
    .ListIndex = .NewIndex
    .Selected(.ListIndex) = False
    .Refresh
End With

If List2.ListCount > 200 Then
    Do
        List2.RemoveItem (0)
    Loop Until List2.ListCount <= 200
End If

Msgy = ""

    ' end of post message 2
End Sub

Private Sub ProgramFlash_click()
    ' program flash button

    ' if program mode is not 0, then abort the current operation
If ProgramMode <> 0 Then
    Call ProgramMode0
    Msg2 = "Aborted processing."
    Call PostMsg2(Msg2)
    Exit Sub
End If

    ' check the S19 file status
If Not (S19FileMode = 1) Then
    Msg2 = "** ERROR ** Select an S19 source file."
    Call PostMsg2(Msg2)
    Exit Sub

Else
        ' reset the file pointer
    Close #1
    Open S19FileName For Input As #1

End If

    ' check data pipe status
If DataPipe = 1 Then
    If ComPortOpen = False Then
        Msg2 = "** ERROR ** COM port not initialized."
        Call PostMsg2(Msg2)
        Exit Sub
    End If

ElseIf DataPipe = 5 Then
    If EthernetConnection = False Then
        Msg2 = "** ERROR ** Ethernet connection not initialized."
        Call PostMsg2(Msg2)
        Exit Sub
    End If
    
Else
    Msg2 = "Invalid DataPipe in ProgramFlash: " & DataPipe
    Call PostMsg2(Msg2)
    Exit Sub

End If

    ' flush the com port buffers
Call FlushDataPipe

    ' reset the interface unit
TransmitPacket(0) = &HF1
TransmitPacket(1) = &HA5
TransmitPacketLength = 2
Call SendAPacket

    ' update button status
ProgramFlash.Caption = "Abort"
VerifyFlash.Enabled = False
SelectDataPipe.Enabled = False
SelectSourceFile.Enabled = False

    ' initialize error counter
VerifyErrorCount = 0

    ' just starting, force program mode to switch
ProgramMode = 21
FailTimer = FailTimerReset
    
    ' all processing now proceeds through the timer 1 interrupt routine
    ' end of program flash
End Sub

Private Sub ProgramMode0()
    ' program mode 0 processing
    ' abort all processing
    ' action:  set program mode = 0
    '          inform the operator

Call UpdateProgramMode(0)

Msg2 = "Aborting.  ProgramMode = 0."
Call PostMsg2(Msg2)

    ' enable com port selection button
SelectDataPipe.Enabled = True

    ' enable file selection button
SelectSourceFile.Enabled = True

    ' update and enable the program button
ProgramFlash.Caption = "Program FLASH"
ProgramFlash.Enabled = True

    ' update and enable the verify button
VerifyFlash.Caption = "Verify FLASH"
VerifyFlash.Enabled = True

    ' end of program mode 0
End Sub

Private Sub ProgramMode21()
    ' waiting for "91"

Call GetAByte

    ' check it
If InData = &H91 Then
        ' correct response
    Call UpdateProgramMode(22)

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E21"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' unexpected stuff read, ignore it
    Msg2 = "Unexpected byte read from AVT interface [91]: $" & Hex$(InData)
    Call PostMsg2(Msg2)

End If

If FailTimer = 0 Then
    Msg2 = "FailTimer expired.  Program mode is 21.  E21_A"
    Call PostMsg2(Msg2)
    Call ProgramMode0
End If

    ' end of program mode 21
End Sub

Private Sub ProgramMode22()
    ' waiting for "12" or "2E"

Call GetAByte

    ' check it
If InData = &H12 Then
        ' response for normal idle state, advance the program mode
    Call UpdateProgramMode(23)

ElseIf InData = &H2E Then
        ' response for boot loader state, advance the program mode
    Call UpdateProgramMode(28)

ElseIf InData = -1 Then
        ' error, nothing read
    Msg2 = "Timeout reading data. E22"
    Call PostMsg2(Msg2)
    Call ProgramMode0

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [12/2E]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 22
End Sub

Private Sub ProgramMode23()
    ' waiting for "92" response

Call GetAByte

    ' check it
If InData = &H92 Then
        ' correct response
    Call UpdateProgramMode(24)

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E23"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [92]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 23
End Sub

Private Sub ProgramMode24()
    ' waiting for "04" response

Call GetAByte

    ' check it
If InData = &H4 Then
        ' correct response
    Call UpdateProgramMode(25)

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E24"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [04]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 24
End Sub

Private Sub ProgramMode25()
    ' waiting for "xx" response; firmware version report

Call GetAByte

    ' check it
If InData <> -1 Then
        ' normal startup idle state
    Msg1 = "AVT interface at startup idle.  Version:  $" & Hex$(InData)
    Call PostMsg1(Msg1)

        ' advance the program mode
    Call UpdateProgramMode(90)
    FailTimer = FailTimerReset / 3

        ' message to operator
    Msg1 = "Flushing Port Buffers.  Short delay.  Please wait."
    Call PostMsg1(Msg1)

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E25"
        Call PostMsg2(Msg2)
        Call ProgramMode0
    
    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [xx]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 25
End Sub

Private Sub ProgramMode26()
    ' waiting for "91"

Call GetAByte

    ' check it
If InData = &H91 Then
        ' correct response
    Call UpdateProgramMode(27)
    Call ProgramMode27

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E26"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [91]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0
    Exit Sub

End If

    ' end of program mode 26
End Sub

Private Sub ProgramMode27()
    ' waiting for "2E"

Call GetAByte

    ' check it
If InData = &H2E Then
        ' correct response
    Call UpdateProgramMode(28)
    Call ProgramMode28

ElseIf InData = -1 Then
        ' error, nothing read
    Msg2 = "Timeout reading data. E27"
    Call PostMsg2(Msg2)
    Call ProgramMode0

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [2E]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 27
End Sub

Private Sub ProgramMode28()
    ' waiting for "92" response

Call GetAByte

    ' check it
If InData = &H92 Then
        ' correct response
    Call UpdateProgramMode(29)
    Call ProgramMode29

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E28"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [92]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 28
End Sub

Private Sub ProgramMode29()
    ' waiting for "04" response

Call GetAByte

    ' check it
If InData = &H4 Then
        ' correct response
    Call UpdateProgramMode(30)
    Call ProgramMode30

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E29"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [04]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 29
End Sub

Private Sub ProgramMode30()
    ' waiting for "xx" response; firmware version report

Call GetAByte

    ' check it
If InData <> -1 Then
        ' successful switch to FLASH mode
    Msg1 = "AVT interface in FLASH mode.  Version:  $" & Hex$(InData)
    Call PostMsg1(Msg1)
        
        ' AVT interface is in flash mode, advance state
    Call UpdateProgramMode(41)
    FailTimer = FailTimerReset

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E30"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [xx]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 30
End Sub

Private Sub ProgramMode41()
    ' read, store and send the first block of data
    
    ' start the first record and the first block
Call StartNewRecord

If GoodRecord <> True Then
    Call ProgramMode0
    Exit Sub
End If

    ' line address is the starting address of the current record
    ' pointer address is the address of the data currently being pointed at
PtrAddr = LineAddr

    ' check to see if this new record and new block start on an even boundry
ChkAddr = (LineAddr And &HFF)

If ChkAddr <> 0 Then
    Msg1 = "Starting address not an even block.  Address: " & Hex$(LineAddr)
    Call PostMsg1(Msg1)
    Call ProgramMode0
    Exit Sub
End If

    ' get the starting address of this block of data
BlockAddr = LineAddr

    ' initialize the block index
BlockIndex = 0

Do
    If LineCount = 0 Then
            ' throw out the checksum byte
        CharPair = Input$(2, #1)
            ' throw out the cr and lf
        CharPair = Input$(2, #1)
        Call StartNewRecord

            ' last block just read
        If GoodRecord <> True Then
            If BlockIndex <> 0 Then
                Call PadBlock
                Call SendBlock
                Call UpdateProgramMode(48)
                FailTimer = FailTimerReset
                Exit Sub

            Else
                Call ProgramMode0
                Exit Sub
            
            End If
        End If

            ' have to start a new block
        If PtrAddr <> LineAddr Then
            If BlockIndex <> 0 Then
                Call PadBlock
                Call SendBlock
                Call UpdateProgramMode(43)
                FailTimer = FailTimerReset
                Exit Sub

            Else
                Call ProgramMode0
                Exit Sub

            End If
        End If
    End If

    CharPair = Input$(2, #1)
    BlockBuff(BlockIndex) = Number2(CharPair)
    BrandNewRecord = False
    BlockIndex = BlockIndex + 1
    PtrAddr = PtrAddr + 1
    LineCount = LineCount - 1

    If BlockIndex = 256 Then
        Call SendBlock
        Call UpdateProgramMode(43)
        FailTimer = FailTimerReset
        Exit Sub
    End If
Loop

    ' end of program mode 41
End Sub

Private Sub ProgramMode42()
    ' read, store, and send subsequent block of data

If LineCount = 0 Then
        ' throw out the checksum byte
    CharPair = Input$(2, #1)
        ' throw out the cr and lf bytes
    CharPair = Input$(2, #1)
    Call StartNewRecord
End If

If BrandNewRecord = True Then
    PtrAddr = LineAddr
    BlockAddr = LineAddr
Else
    BlockAddr = PtrAddr
End If

BlockIndex = 0
    
ChkAddr = (BlockAddr And &HFF)

If ChkAddr <> 0 Then
    Msg1 = "Starting address not an even block.  Address: " & Hex$(LineAddr)
    Call PostMsg1(Msg1)
    Call ProgramMode0
    Exit Sub
End If

Do
    If LineCount = 0 Then
            ' throw out the check sum byte
        CharPair = Input$(2, #1)
            ' throw out the cr and lf bytes
        CharPair = Input$(2, #1)
        Call StartNewRecord

            ' last block just read
        If GoodRecord <> True Then
            If BlockIndex <> 0 Then
                Call PadBlock
                Call SendBlock
                Call UpdateProgramMode(48)
                FailTimer = FailTimerReset
                Exit Sub

            Else
                Call ProgramMode0
                Exit Sub

            End If
        End If

        If PtrAddr <> LineAddr Then
            If BlockIndex <> 0 Then
                Call PadBlock
                Call SendBlock
                Call UpdateProgramMode(43)
                FailTimer = FailTimerReset
                Exit Sub

            Else
                Call ProgramMode0
                Exit Sub

            End If
        End If
    End If

    CharPair = Input$(2, #1)
    BlockBuff(BlockIndex) = Number2(CharPair)
    BrandNewRecord = False
    BlockIndex = BlockIndex + 1
    PtrAddr = PtrAddr + 1
    LineCount = LineCount - 1

    If BlockIndex = 256 Then
        Call SendBlock
        Call UpdateProgramMode(43)
        FailTimer = FailTimerReset
        Exit Sub

    End If
Loop

    ' end of program mode 42
End Sub

Private Sub ProgramMode43()
    ' waiting for "61" response

Call GetAByte

    ' check it
If InData = &H61 Then
        ' correct response
    Call UpdateProgramMode(44)
    Call ProgramMode44

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E43"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [61]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 43
End Sub

Private Sub ProgramMode44()
    ' waiting for "3A" response

Call GetAByte

    ' check it
If InData = &H3A Then
        ' correct response
    Call SendDumpCommand
    Call UpdateProgramMode(45)
    FailTimer = FailTimerReset

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E44"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [3A]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 44
End Sub

Private Sub ProgramMode45()
    ' waiting for "61" response

Call GetAByte

    ' check it
If InData = &H61 Then
        ' correct response
    Call UpdateProgramMode(46)
    Call ProgramMode46

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E45"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [61]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 45
End Sub

Private Sub ProgramMode46()
    ' waiting for "37" response

Call GetAByte

    ' check it
If InData = &H37 Then
        ' correct response, initialize the buffer index
    VerifyIndex = 0
        ' initialize the block error counter
    BlockErrorCount = 0
        ' update the mode
    Call UpdateProgramMode(47)
    Call ProgramMode47

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E46"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [37]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 46
End Sub

Private Sub ProgramMode47()
    ' verify the block

Do
    Call GetAByte

    If InData <> -1 Then
            ' response received, check it
        If InData = BlockBuff(VerifyIndex) Then
                ' correct response, don't do anything, continue processing

        Else
                ' record the error
            BlockErrorCount = BlockErrorCount + 1

        End If

        VerifyIndex = VerifyIndex + 1
            ' check if index has reached the end

        If VerifyIndex = 256 Then
            VerifyIndex = 0
            If BlockErrorCount = 0 Then
                Msg1 = "                           -- Verified."
                Call PostMsg1(Msg1)

            Else
                Msg1 = "Verification errors: " & BlockErrorCount
                Call PostMsg1(Msg1)

            End If

            VerifyErrorCount = VerifyErrorCount + BlockErrorCount
            Call UpdateProgramMode(42)
            FailTimer = FailTimerReset
            Exit Sub
        
        End If

    Else
            ' nothing read
        If FailTimer > 0 Then
                ' leave to wait some more
            Exit Sub
        Else
            Msg2 = "Timeout reading data. E47"
            Call PostMsg2(Msg2)
            Call ProgramMode0
            Exit Sub
        End If

    End If
        
Loop

    ' end of program mode 47
End Sub

Private Sub ProgramMode48()
    ' waiting for last "61" response

Call GetAByte

    ' check it
If InData = &H61 Then
        ' correct response
    Call UpdateProgramMode(49)
    Call ProgramMode49

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more
        Exit Sub
    Else
        Msg2 = "Timeout reading data. E48"
        Call PostMsg2(Msg2)
        Call ProgramMode0
        Exit Sub
    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [61]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0
    Exit Sub

End If

    ' end of program mode 48
End Sub

Private Sub ProgramMode49()
    ' waiting for last "3A" response

Call GetAByte

    ' check it
If InData = &H3A Then
        ' correct response
    Call SendDumpCommand
    Call UpdateProgramMode(50)
    FailTimer = FailTimerReset

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more
        Exit Sub
    Else
        Msg2 = "Timeout reading data. E49"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [3A]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 49
End Sub

Private Sub ProgramMode50()
    ' waiting for last "61" response

Call GetAByte

    ' check it
If InData = &H61 Then
        ' correct response
    Call UpdateProgramMode(51)
    Call ProgramMode51

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E50"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [61]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 50
End Sub

Private Sub ProgramMode51()
    ' waiting for last "37" response

Call GetAByte

    ' check it
If InData = &H37 Then
        ' correct response
        ' initialize error counter
    BlockErrorCount = 0
        ' initialize the buffer index
    VerifyIndex = 0
        ' update the mode
    Call UpdateProgramMode(52)
    Call ProgramMode52

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E51"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [37]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 51
End Sub

Private Sub ProgramMode52()
    ' verify the block
    
Do
    Call GetAByte

    If InData <> -1 Then
            ' response received, check it
        If InData = BlockBuff(VerifyIndex) Then
                ' correct response, don't do anything, continue processing

        Else
                ' record the error
            BlockErrorCount = BlockErrorCount + 1

        End If

        VerifyIndex = VerifyIndex + 1
            ' check if index has reached the end

        If VerifyIndex = 256 Then
            VerifyIndex = 0
            VerifyErrorCount = VerifyErrorCount + BlockErrorCount
            If VerifyErrorCount = 0 Then
                Msg1 = "  "
                Call PostMsg1(Msg1)
                Msg1 = "***  Success ***.  AVT interface FLASH Updated."
                Call PostMsg1(Msg1)
    
                Msg1 = "Exit this program and Re-Boot the AVT interface."
                Call PostMsg1(Msg1)

            Else
                Msg1 = "Verification errors: " & VerifyErrorCount
                Call PostMsg1(Msg1)
            
            End If

            Call ProgramMode0
            Exit Sub

        End If

    Else
            ' nothing read
        If FailTimer > 0 Then
                ' leave to wait some more
            Exit Sub
        Else
            Msg2 = "Timeout reading data. E52"
            Call PostMsg2(Msg2)
            Call ProgramMode0
            Exit Sub
        End If

    End If

Loop

    ' end of program mode 52
End Sub

Private Sub ProgramMode61()
    ' waiting for "91"

Call GetAByte

    ' check it
If InData = &H91 Then
        ' correct response
    Call UpdateProgramMode(62)

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E61"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [91]: $" & Hex$(InData)
    Call PostMsg2(Msg2)

End If

If FailTimer = 0 Then
    Msg2 = "FailTimer expired.  Program mode is 21.  E21_A"
    Call PostMsg2(Msg2)
    Call ProgramMode0
End If

    ' end of program mode 61
End Sub

Private Sub ProgramMode62()
    ' waiting for "12" or "2E"

Call GetAByte

    ' check it
If InData = &H12 Then
        ' response for normal idle state, advance the program mode
    Call UpdateProgramMode(63)

ElseIf InData = &H2E Then
        ' response for boot loader state, advance the program mode
    Call UpdateProgramMode(68)
    Call ProgramMode68

ElseIf InData = -1 Then
        ' error, nothing read
    Msg2 = "Timeout reading data. E62"
    Call PostMsg2(Msg2)
    Call ProgramMode0

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [12/2E]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 62
End Sub

Private Sub ProgramMode63()
    ' waiting for "92" response

Call GetAByte

    ' check it
If InData = &H92 Then
        ' correct response
    Call UpdateProgramMode(64)

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E63"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [92]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 63
End Sub

Private Sub ProgramMode64()
    ' waiting for "04" response

Call GetAByte

    ' check it
If InData = &H4 Then
        ' correct response
    Call UpdateProgramMode(65)

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E64"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [04]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 64
End Sub

Private Sub ProgramMode65()
    ' waiting for "xx" response; firmware version report

Call GetAByte

    ' check it
If InData <> -1 Then
        ' normal startup idle state
    Msg1 = "AVT interface at startup idle.  Version:  $" & Hex$(InData)
    Call PostMsg1(Msg1)

        ' advance the program mode
    Call UpdateProgramMode(91)
    FailTimer = FailTimerReset / 3

        ' message to operator
    Msg1 = "Flushing Port Buffers.  Short delay.  Please wait."
    Call PostMsg1(Msg1)

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E65"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [xx]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 65
End Sub

Private Sub ProgramMode66()
    ' waiting for "91"

Call GetAByte

    ' check it
If InData = &H91 Then
        ' correct response
    Call UpdateProgramMode(67)

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E66"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [91]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 66
End Sub

Private Sub ProgramMode67()
    ' waiting for "2E"

Call GetAByte

    ' check it
If InData = &H2E Then
        ' correct response
    Call UpdateProgramMode(68)

ElseIf InData = -1 Then
        ' error, nothing read
    Msg2 = "Timeout reading data. E67"
    Call PostMsg2(Msg2)
    Call ProgramMode0

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [2E]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 67
End Sub

Private Sub ProgramMode68()
    ' waiting for "92" response

Call GetAByte

    ' check it
If InData = &H92 Then
        ' correct response
    Call UpdateProgramMode(69)

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E68"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [92]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 68
End Sub

Private Sub ProgramMode69()
    ' waiting for "04" response

Call GetAByte

    ' check it
If InData = &H4 Then
        ' correct response
    Call UpdateProgramMode(70)

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E69"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [04]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 69
End Sub

Private Sub ProgramMode70()
    ' waiting for "xx" response; firmware version report

Call GetAByte

    ' check it
If InData <> -1 Then
        ' successful switch to FLASH mode
    Msg1 = "AVT interface in FLASH mode.  Version:  $" & Hex$(InData)
    Call PostMsg1(Msg1)
        
        ' AVT interface is in flash mode, advance state
    Call UpdateProgramMode(71)
    FailTimer = FailTimerReset

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E70"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [xx]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 70
End Sub

Private Sub ProgramMode71()
    ' read and store the first block of data
    ' send the dump command
    
    ' start the first record and the first block
Call StartNewRecord

If GoodRecord <> True Then
    Call ProgramMode0
    Exit Sub
End If

    ' line address is the starting address of the current record
    ' pointer address is the address of the data currently being pointed at
PtrAddr = LineAddr

    ' check to see if this new record and new block start on an even boundry
ChkAddr = (LineAddr And &HFF)

If ChkAddr <> 0 Then
    Msg1 = "Starting address not an even block.  Address: " & Hex$(LineAddr)
    Call PostMsg1(Msg1)
    Call ProgramMode0
    Exit Sub
End If

    ' get the starting address of this block of data
BlockAddr = LineAddr

    ' initialize the block index
BlockIndex = 0

Do
    If LineCount = 0 Then
            ' throw out the checksum byte
        CharPair = Input$(2, #1)
            ' throw out the cr and lf
        CharPair = Input$(2, #1)
        Call StartNewRecord

            ' last block just read
        If GoodRecord <> True Then
            If BlockIndex <> 0 Then
                Call PadBlock
                Call SendDumpCommand
                Call UpdateProgramMode(76)
                FailTimer = FailTimerReset
                Exit Sub

            Else
                Call ProgramMode0
                Exit Sub
            
            End If
        End If

            ' have to start a new block
        If PtrAddr <> LineAddr Then
            If BlockIndex <> 0 Then
                Call PadBlock
                Call SendDumpCommand
                Call UpdateProgramMode(73)
                FailTimer = FailTimerReset
                Exit Sub

            Else
                Call ProgramMode0
                Exit Sub

            End If
        End If
    End If

    CharPair = Input$(2, #1)
    BlockBuff(BlockIndex) = Number2(CharPair)
    BrandNewRecord = False
    BlockIndex = BlockIndex + 1
    PtrAddr = PtrAddr + 1
    LineCount = LineCount - 1

    If BlockIndex = 256 Then
        Call SendDumpCommand
        Call UpdateProgramMode(73)
        FailTimer = FailTimerReset
        Exit Sub
    End If
Loop

    ' end of program mode 71
End Sub

Private Sub ProgramMode72()
    ' read and store subsequent block of data
    ' send the dump command

If LineCount = 0 Then
        ' throw out the checksum byte
    CharPair = Input$(2, #1)
        ' throw out the cr and lf bytes
    CharPair = Input$(2, #1)
    Call StartNewRecord
End If

If BrandNewRecord = True Then
    PtrAddr = LineAddr
    BlockAddr = LineAddr
Else
    BlockAddr = PtrAddr
End If

BlockIndex = 0
    
ChkAddr = (BlockAddr And &HFF)

If ChkAddr <> 0 Then
    Msg1 = "Starting address not an even block.  Address: " & Hex$(LineAddr)
    Call PostMsg1(Msg1)
    Call ProgramMode0
    Exit Sub
End If

Do
    If LineCount = 0 Then
            ' throw out the check sum byte
        CharPair = Input$(2, #1)
            ' throw out the cr and lf bytes
        CharPair = Input$(2, #1)
        Call StartNewRecord

            ' last block just read
        If GoodRecord <> True Then
            If BlockIndex <> 0 Then
                Call PadBlock
                Call SendDumpCommand
                Call UpdateProgramMode(76)
                FailTimer = FailTimerReset
                Exit Sub

            Else
                Call ProgramMode0
                Exit Sub

            End If
        End If

        If PtrAddr <> LineAddr Then
            If BlockIndex <> 0 Then
                Call PadBlock
                Call SendDumpCommand
                Call UpdateProgramMode(73)
                FailTimer = FailTimerReset
                Exit Sub

            Else
                Call ProgramMode0
                Exit Sub

            End If
        End If
    End If

    CharPair = Input$(2, #1)
    BlockBuff(BlockIndex) = Number2(CharPair)
    BrandNewRecord = False
    BlockIndex = BlockIndex + 1
    PtrAddr = PtrAddr + 1
    LineCount = LineCount - 1

    If BlockIndex = 256 Then
        Call SendDumpCommand
        Call UpdateProgramMode(73)
        FailTimer = FailTimerReset
        Exit Sub

    End If
Loop

    ' end of program mode 72
End Sub

Private Sub ProgramMode73()
    ' waiting for "61" response

Call GetAByte

    ' check it
If InData = &H61 Then
        ' correct response
    Call UpdateProgramMode(74)
    Call ProgramMode74

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E73"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [61]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 73
End Sub

Private Sub ProgramMode74()
    ' waiting for "37" response

Call GetAByte

    ' check it
If InData = &H37 Then
        ' correct response, initialize the buffer index
    VerifyIndex = 0
        ' initialize the block error counter
    BlockErrorCount = 0
        ' update the mode
    Call UpdateProgramMode(75)
    Call ProgramMode75

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E74"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [37]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 74
End Sub

Private Sub ProgramMode75()
    ' verify the block

Do
    Call GetAByte

    If InData <> -1 Then
            ' response received, check it
        If InData = BlockBuff(VerifyIndex) Then
                ' correct response, don't do anything, continue processing

        Else
                ' record the error
            BlockErrorCount = BlockErrorCount + 1

        End If

        VerifyIndex = VerifyIndex + 1
            ' check if index has reached the end

        If VerifyIndex = 256 Then
            VerifyIndex = 0
            If BlockErrorCount = 0 Then
                Msg1 = "Block $" & Hex$(BlockAddr) & "     -- Verified."
                Call PostMsg1(Msg1)

            Else
                Msg1 = "Block $" & Hex$(BlockAddr) & "     -- Verify errors: " & BlockErrorCount
                Call PostMsg1(Msg1)

            End If

            VerifyErrorCount = VerifyErrorCount + BlockErrorCount
            Call UpdateProgramMode(72)
            FailTimer = FailTimerReset
            Exit Sub
        
        End If

    Else

            ' nothing read
        If FailTimer > 0 Then
                ' leave to wait some more
            Exit Sub
        Else
            Msg2 = "Timeout reading data. E75"
            Call PostMsg2(Msg2)
            Call ProgramMode0
            Exit Sub
        End If

    End If
        
Loop

    ' end of program mode 75
End Sub

Private Sub ProgramMode76()
    ' waiting for last "61" response

Call GetAByte

    ' check it
If InData = &H61 Then
        ' correct response
    Call UpdateProgramMode(77)
    Call ProgramMode77

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E76"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [61]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 76
End Sub

Private Sub ProgramMode77()
    ' waiting for last "37" response

Call GetAByte

    ' check it
If InData = &H37 Then
        ' correct response
        ' initialize error counter
    BlockErrorCount = 0
        ' initialize the buffer index
    VerifyIndex = 0
        ' update the mode
    Call UpdateProgramMode(78)
    Call ProgramMode78

ElseIf InData = -1 Then
        ' nothing read
    If FailTimer > 0 Then
            ' leave to wait some more

    Else
        Msg2 = "Timeout reading data. E77"
        Call PostMsg2(Msg2)
        Call ProgramMode0

    End If

Else
        ' error, wrong stuff read
    Msg2 = "Wrong response from AVT interface [37]: $" & Hex$(InData)
    Call PostMsg2(Msg2)
    Call ProgramMode0

End If

    ' end of program mode 77
End Sub

Private Sub ProgramMode78()
    ' verify the block
    
Do
    Call GetAByte

    If InData <> -1 Then
            ' response received, check it
        If InData = BlockBuff(VerifyIndex) Then
                ' correct response, don't do anything, continue processing

        Else
                ' record the error
            BlockErrorCount = BlockErrorCount + 1

        End If

        VerifyIndex = VerifyIndex + 1
            ' check if index has reached the end

        If VerifyIndex = 256 Then
            VerifyIndex = 0
            VerifyErrorCount = VerifyErrorCount + BlockErrorCount
            If VerifyErrorCount = 0 Then
                Msg1 = "Block $" & Hex$(BlockAddr) & "     -- Verified."
                Call PostMsg1(Msg1)
                Msg1 = "  "
                Call PostMsg1(Msg1)
                Msg1 = "***  Success ***.  AVT interface FLASH Verified."
                Call PostMsg1(Msg1)
    
            Else
                If BlockErrorCount <> 0 Then
                    Msg1 = "Block $" & Hex$(BlockAddr) & "     -- Verify errors: " & BlockErrorCount
                    Call PostMsg1(Msg1)
                End If
                Msg1 = "  "
                Call PostMsg1(Msg1)
                Msg1 = "###  Verify Failed  ###     Total errors: " & VerifyErrorCount
                Call PostMsg1(Msg1)
            
            End If

            Call ProgramMode0
        
        End If

    Else
            ' nothing read
        If FailTimer > 0 Then
                ' leave to wait some more
            Exit Sub
        Else
            Msg2 = "Timeout reading data. E78"
            Call PostMsg2(Msg2)
            Call ProgramMode0
            Exit Sub
        End If

    End If

Loop

    ' end of program mode 78
End Sub

Private Sub ProgramMode90()
    ' wait one time out period, flush the data pipe

Call FlushDataPipe

If FailTimer > 0 Then
        ' leave to wait some more

Else
        ' send mode switch command to flash mode
    TransmitPacket(0) = &HE1
    TransmitPacket(1) = &H96
    TransmitPacketLength = 2
    Call SendAPacket
        
        ' advance the program mode
    Call UpdateProgramMode(26)
    FailTimer = FailTimerReset

End If

    ' end of program mode 90
End Sub

Private Sub ProgramMode91()
    ' wait one time out period, flush the data pipe

Call FlushDataPipe

If FailTimer > 0 Then
        ' leave to wait some more

Else
        ' send mode switch command to flash mode
    TransmitPacket(0) = &HE1
    TransmitPacket(1) = &H96
    TransmitPacketLength = 2
    Call SendAPacket
        
        ' advance the program mode
    Call UpdateProgramMode(66)
    FailTimer = FailTimerReset

End If

    ' end of program mode 91
End Sub

Private Function ReadFifo1()
    ' read a byte from fifo 1

    ' check if the fifo is empty
If EmptyFlag1 = True Then
    ReadFifo1 = -1

Else
        ' fetch a byte from the fifo
    ReadFifo1 = Fifo1(Tail1)

        ' check if the tail has reached the top
    If Tail1 = Top1 Then
            ' roll tail over to the bottom
        Tail1 = Bottom1

    Else
            ' increment the tail
        Tail1 = Tail1 + 1

    End If

        ' check if the tail has reached the head
    If Tail1 = Head1 Then
        EmptyFlag1 = True
    End If

        ' update the full flag
    FullFlag1 = False

End If

    ' end of read fifo 1
End Function

Private Sub SelectDataPipe_click()
    ' select the data pipe

    ' if we're in the isr, exit for now
If TimerIsrActive = True Then
    Msg2 = "Com setup attempt failed, timer stopped. --> Try again !"
    Call PostMsg2(Msg2)
    Timer1.Enabled = False
    Exit Sub
End If

    ' if we're in the isr, exit for now
If WinsockIsrActive = True Then
    Msg2 = "Com setup attempt failed, timer stopped. --> Try again !"
    Call PostMsg2(Msg2)
    Timer1.Enabled = False
    Exit Sub
End If

    ' disable the timer
Timer1.Enabled = False
TimerIsrActive = False

    ' close the ethernet connection
If EthernetConnection = True Then
    Winsock1Data.Close
    Msg2 = "Ethernet connection closed."
    Call PostMsg2(Msg2)

    EthernetConnection = False
    WinsockIsrActive = False

End If

    ' close the open com port
If ComPortOpen = True Then
    stat = UnInitializePort&(ComPort)
    If stat <> RS232ERR_NONE Then
        Msg2 = "Error: " & stat & " closing COM port: " & ComPort
        Call PostMsg2(Msg2)
    Else
        Msg2 = "Closed COM port: " & ComPort
        Call PostMsg2(Msg2)
    End If

    ComPortOpen = False

End If

    ' clear the com settings window
Text3.Text = ""

    ' show the form
Form2.Show

    ' end of select data pipe
End Sub

Private Sub SelectSourceFile_click()
    ' select input file button

    ' close the open file, if necessary
Close #1

    ' clear the file text window
Text2.Text = ""

    ' clear/initialize the variables
CommonDialog1.FileName = "*.s19"
S19FileName = ""
S19FileMode = 0

    ' cancelerror is true
CommonDialog1.CancelError = True

On Error GoTo ErrHandler

    ' set flags
CommonDialog1.Flags = cdlOFNHideReadOnly

    ' set filters
CommonDialog1.Filter = "S19 Files (*.S19)"
CommonDialog1.DefaultExt = "s19"

    ' specify default filter
CommonDialog1.FilterIndex = 1

    ' set the default directory
CommonDialog1.InitDir = CurDir

    ' display the open dialog box
CommonDialog1.ShowOpen

S19FileName = CommonDialog1.FileName

If S19FileName = "" Then
    Msg2 = "No S19 source file selected."
    Call PostMsg2(Msg2)
Else
    Open S19FileName For Input As #1
    S19FileMode = 1
    Text2.Text = S19FileName
End If

Exit Sub

    ' user pressed the cancel button
ErrHandler:
    Msg2 = "S19 source file selection cancelled."
    Call PostMsg2(Msg2)

Exit Sub

    ' end of select source file
End Sub
Private Sub SendAPacket()
    ' send a packet

Dim IndexP As Integer

If TransmitPacketLength = 0 Then
    Exit Sub
End If
    
        ' send the data packet via the com port
If DataPipe = 1 Then
    For IndexP = 0 To TransmitPacketLength - 1
        stat = PutByte(ComPort, TransmitPacket(IndexP))
        If stat <> RS232ERR_NONE Then
            Msg2 = "Error in put byte: " & stat
            Call PostMsg2(Msg2)
        End If
    Next IndexP

        ' this line is supposed to speed up sending bytes
    stat = ser_rs232_putpacket(ComPort, 0, 0)
    If stat <> RS232ERR_NONE Then
        Msg2 = "Error in put packet: " & stat
        Call PostMsg2(Msg2)
    End If

        ' send the data packet via the ethernet connection
ElseIf DataPipe = 5 Then

        ' declare an outbound array of type byte
    ReDim OutBoundData(0 To TransmitPacketLength - 1) As Byte

        ' copy the data to the outbound array
    For IndexP = 0 To TransmitPacketLength - 1
        OutBoundData(IndexP) = TransmitPacket(IndexP) And &HFF
    Next IndexP

        ' send the data out the ethernet connection
    Winsock1Data.SendData OutBoundData

Else
    Msg2 = "Invalid DataPipe in SendAPacket: " & DataPipe
    Call PostMsg2(Msg2)

End If

    ' end of send a packet
End Sub

Private Sub SendBlock()
    ' send the block

        ' compute the start address as four bytes
    Byte3 = Int(((BlockAddr / 256) / 256) / 256) And &HFF
    Byte2 = Int((BlockAddr / 256) / 256) And (&HFF)
    Byte1 = Int(BlockAddr / 256) And (&HFF)
    Byte0 = BlockAddr And &HFF

    TransmitPacket(0) = &H57
    TransmitPacket(1) = &H3A
    TransmitPacket(2) = Byte3
    TransmitPacket(3) = Byte2
    TransmitPacket(4) = Byte1
    TransmitPacket(5) = Byte0
    TransmitPacket(6) = &H1
    TransmitPacket(7) = &H0

    For Ix = 0 To 255
        TransmitPacket(Ix + 8) = BlockBuff(Ix)
    Next Ix

    TransmitPacketLength = 8 + 256

    Call SendAPacket

    Msg1 = "Block  $" & Hex$(BlockAddr) & "     -- Sent."
    Call PostMsg1(Msg1)

    ' end of send block
End Sub

Private Sub SendDumpCommand()
    ' assemble and send dump command

    Byte3 = Int(((BlockAddr / 256) / 256) / 256) And &HFF
    Byte2 = Int((BlockAddr / 256) / 256) And (&HFF)
    Byte1 = Int(BlockAddr / 256) And (&HFF)
    Byte0 = BlockAddr And &HFF

    TransmitPacket(0) = &H57
    TransmitPacket(1) = &H37
    TransmitPacket(2) = Byte3
    TransmitPacket(3) = Byte2
    TransmitPacket(4) = Byte1
    TransmitPacket(5) = Byte0
    TransmitPacket(6) = &H1
    TransmitPacket(7) = &H0
    TransmitPacketLength = 8

    Call SendAPacket

    ' end of send dump command
End Sub

Private Sub StartNewRecord()
    ' this routine assumes the file pointer is at the beginning of a new line
    ' thus a new record
    ' read in the record type
    ' compute the address - returned in LineAddr
    ' compute the remaining line length - returned in LineLength

GoodRecord = True
BrandNewRecord = True

Record = Input$(2, #1)
If EOF(1) Then
    Msg2 = "S19 EOF encountered."
    Call PostMsg2(Msg2)
    GoodRecord = False
    BrandNewRecord = False
    Exit Sub
End If

CharPair = Input$(2, #1)
LineCount = Number2(CharPair)

If Record = "S1" Then

    CharPair = Input$(2, #1)
    Addr1 = Number2(CharPair)

    CharPair = Input$(2, #1)
    Addr0 = Number2(CharPair)

    LineAddr = (Addr1 * 256) + Addr0

    LineCount = LineCount - 3
        ' subtract 3 = 2 address bytes and 1 CRC byte

ElseIf Record = "S2" Then

    CharPair = Input$(2, #1)
    Addr2 = Number2(CharPair)

    CharPair = Input$(2, #1)
    Addr1 = Number2(CharPair)

    CharPair = Input$(2, #1)
    Addr0 = Number2(CharPair)

    LineAddr = (Addr2 * 256 * 256) + (Addr1 * 256) + Addr0

    LineCount = LineCount - 4
        ' subtract 4 = 3 address bytes and 1 CRC byte

ElseIf Record = "S3" Then

    CharPair = Input$(2, #1)
    Addr3 = Number2(CharPair)

    CharPair = Input$(2, #1)
    Addr2 = Number2(CharPair)

    CharPair = Input$(2, #1)
    Addr1 = Number2(CharPair)

    CharPair = Input$(2, #1)
    Addr0 = Number2(CharPair)

    LineAddr = (Addr3 * 256 * 256 * 256) + (Addr2 * 256 * 256) + (Addr1 * 256) + Addr0

    LineCount = LineCount - 5
        ' subtract 5 = 4 address bytes and 1 CRC byte

ElseIf Record = "S5" Then
    Msg2 = "S5 record detected."
    Call PostMsg2(Msg2)
    GoodRecord = False
    BrandNewRecord = False

ElseIf Record = "S7" Then
    Msg2 = "S7 record detected."
    Call PostMsg2(Msg2)
    GoodRecord = False
    BrandNewRecord = False

ElseIf Record = "S8" Then
    Msg2 = "S8 record detected.  Operation terminated."
    Call PostMsg2(Msg2)
    GoodRecord = False
    BrandNewRecord = False

ElseIf Record = "S9" Then
    Msg2 = "S9 record detected."
    Call PostMsg2(Msg2)
    GoodRecord = False
    BrandNewRecord = False

Else
    Msg2 = "Unexpected record found."
    Call PostMsg2(Msg2)
    GoodRecord = False
    BrandNewRecord = False

End If

    ' end of start new record
End Sub

Private Sub TestGetByte_Click()

FailTimer = FailTimerReset
Call GetAByte
Msg1 = "Byte read: " & Hex$(InData) & "     FailTimer: " & FailTimer
Call PostMsg1(Msg1)

End Sub

Private Sub Timer1_Timer()
    ' timer 1 interrupt routine

    ' update the fail timer
If FailTimer > 0 Then
    FailTimer = FailTimer - 1
Else
    FailTimer = 0
End If

    ' check if we are already here
If TimerIsrActive = True Then
    Exit Sub
End If

    ' we are now here
TimerIsrActive = True

    ' process according to the current program mode
Select Case ProgramMode

Case Is = 0
    ' do nothing

Case Is = 21
    Call ProgramMode21

Case Is = 22
    Call ProgramMode22

Case Is = 23
    Call ProgramMode23

Case Is = 24
    Call ProgramMode24

Case Is = 25
    Call ProgramMode25

Case Is = 26
    Call ProgramMode26

Case Is = 27
    Call ProgramMode27

Case Is = 28
    Call ProgramMode28

Case Is = 29
    Call ProgramMode29

Case Is = 30
    Call ProgramMode30

Case Is = 41
    Call ProgramMode41

Case Is = 42
    Call ProgramMode42

Case Is = 43
    Call ProgramMode43

Case Is = 44
    Call ProgramMode44

Case Is = 45
    Call ProgramMode45

Case Is = 46
    Call ProgramMode46

Case Is = 47
    Call ProgramMode47

Case Is = 48
    Call ProgramMode48

Case Is = 49
    Call ProgramMode49

Case Is = 50
    Call ProgramMode50

Case Is = 51
    Call ProgramMode51

Case Is = 52
    Call ProgramMode52

Case Is = 61
    Call ProgramMode61

Case Is = 62
    Call ProgramMode62

Case Is = 63
    Call ProgramMode63

Case Is = 64
    Call ProgramMode64

Case Is = 65
    Call ProgramMode65

Case Is = 66
    Call ProgramMode66

Case Is = 67
    Call ProgramMode67

Case Is = 68
    Call ProgramMode68

Case Is = 69
    Call ProgramMode69

Case Is = 70
    Call ProgramMode70

Case Is = 71
    Call ProgramMode71

Case Is = 72
    Call ProgramMode72

Case Is = 73
    Call ProgramMode73

Case Is = 74
    Call ProgramMode74

Case Is = 75
    Call ProgramMode75

Case Is = 76
    Call ProgramMode76

Case Is = 77
    Call ProgramMode77

Case Is = 78
    Call ProgramMode78

Case Is = 90
    Call ProgramMode90

Case Is = 91
    Call ProgramMode91

Case Else
    Msg2 = "Invalid program mode: " & ProgramMode
    Call PostMsg2(Msg2)
    Call ProgramMode0

End Select

    ' time to leave
TimerIsrActive = False

    ' end of timer 1 interrupt routine
End Sub

Private Sub UpdateProgramMode(NewMode As Integer)
    ' update the current program mode
    ' this routine prevents an active subroutine from over writing an abort attempt

If ProgramMode = 0 Then
    Exit Sub

Else
    ProgramMode = NewMode

End If

    ' end of update program mode
End Sub

Private Sub VerifyFlash_Click()
    ' verify flash contents

    ' if program mode is not 0, then abort the current operation
If ProgramMode <> 0 Then
    Call ProgramMode0
    Msg2 = "Aborted processing."
    Call PostMsg2(Msg2)
    Exit Sub
End If

    ' check the S19 file status
If Not (S19FileMode = 1) Then
    Msg2 = "** ERROR ** Select an S19 source file."
    Call PostMsg2(Msg2)
    Exit Sub

Else
        ' reset the file pointer
    Close #1
    Open S19FileName For Input As #1

End If

    ' check data pipe status
If DataPipe = 1 Then
    If ComPortOpen = False Then
        Msg2 = "** ERROR ** COM port not initialized."
        Call PostMsg2(Msg2)
        Exit Sub
    End If

ElseIf DataPipe = 5 Then
    If EthernetConnection = False Then
        Msg2 = "** ERROR ** Ethernet connection not initialized."
        Call PostMsg2(Msg2)
        Exit Sub
    End If
    
Else
    Msg2 = "Invalid DataPipe in ProgramFlash: " & DataPipe
    Call PostMsg2(Msg2)
    Exit Sub

End If

    ' flush the com port buffers
Call FlushDataPipe

    ' reset the interface unit
TransmitPacket(0) = &HF1
TransmitPacket(1) = &HA5
TransmitPacketLength = 2
Call SendAPacket

    ' update button status
VerifyFlash.Caption = "Abort"
ProgramFlash.Enabled = False
SelectDataPipe.Enabled = False
SelectSourceFile.Enabled = False

    ' initialize error counter
VerifyErrorCount = 0

    ' just starting, force program mode to switch
ProgramMode = 61
FailTimer = FailTimerReset
    
    ' all processing now proceeds through the timer 1 interrupt routine
    ' end of verify flash
End Sub

Private Sub Winsock1Data_DataArrival(ByVal IncomingByteCount As Long)
    ' this routine is called when winsock data has arrived

    ' declare local variables
Dim IndexW As Integer

    ' check if I am already in this routine
If WinsockIsrActive = True Then
    Exit Sub
End If

    ' we are now in this routine
WinsockIsrActive = True

    ' get the incoming data
Winsock1Data.GetData ReceiveData, vbByte

    ' initialize the index to the array lower bound
ReceiveDataIndex = LBound(ReceiveData)
    ' get the array upper bound
ReceiveDataUBound = UBound(ReceiveData)

If IncomingByteCount <> (ReceiveDataUBound - ReceiveDataIndex + 1) Then
    Msg2 = "Byte counts are not equal."
    Call PostMsg2(Msg2)
    Msg2 = "IncomingByteCount = " & IncomingByteCount
    Call PostMsg2(Msg2)
    Msg2 = "UBound = " & ReceiveDataUBound & "  LBound = " & ReceiveDataIndex
    Call PostMsg2(Msg2)
End If

    ' write the bytes to fifo 1
For IndexW = ReceiveDataIndex To ReceiveDataUBound
    Call WriteFifo1(ReceiveData(IndexW))
Next IndexW

    ' ready to leave
WinsockIsrActive = False

    ' end of winsock data arrival
End Sub

Private Sub Winsock1Data_Connect()
    ' this routine is called when the winsock connection is complete

    Msg2 = "Ethernet connection complete."
    Call PostMsg2(Msg2)

    EthernetConnection = True

    Text3.Text = "Ethernet IP address: " & IPAddress & "   Port number: " & PortNumber

        ' enable timer 1
    Timer1.Enabled = True

    ' end of winsock connect
End Sub

Private Sub WriteFifo1(WriteByte As Byte)

    ' check if the fifo is full
If FullFlag1 = True Then
    Msg1 = "Fifo1 is full."
    Call PostMsg1(Msg1)

Else
        ' store the byte in the fifo
    Fifo1(Head1) = WriteByte

        ' check if the head pointer has reached the top
    If Head1 = Top1 Then
            ' roll the head pointer over to the bottom
        Head1 = Bottom1

    Else
            ' increment the head pointer
        Head1 = Head1 + 1

    End If

    If Head1 = Tail1 Then
        FullFlag1 = True
    End If

    EmptyFlag1 = False

End If

    ' end of write fifo 1
End Sub

